﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Public Value As Int
	Private mRadius As Int
	Private mX, mY As Int
	Private NeedleBrush As BCBrush
End Sub

Public Sub Initialize (x As Int, y As Int, radius As Int, clr As Int, background As BitmapCreator)
	background.DrawCircle(x, y, radius + 1, clr, True, 0)
	Dim ShortRadius As Int = radius - 5
	For i = 0 To 100 Step 10
		Dim angle As Float = ValueToAngle(i)
		background.DrawLine(x + radius * CosD(angle), y + radius * SinD(angle), _
			x + ShortRadius * CosD(angle), y + ShortRadius * SinD(angle), xui.Color_Black, 1)
	Next
	mRadius = radius
	mX = x
	mY = y
	NeedleBrush = background.CreateBrushFromColor(Rnd(0xff000000, 0xffffffff))
End Sub

Private Sub ValueToAngle (v As Int) As Float
	Return 240 * v / 100 - 90
End Sub

Public Sub Draw (bc As BitmapCreator) As DrawTask
	Dim angle As Float = ValueToAngle(Value)
	Dim p As BCPath
	p.Initialize(mX, mY)
	p.LineTo(mX + 5 * CosD(angle - 30), mY + 5 * SinD(angle - 30))
	p.LineTo(mX + (mRadius - 1) * CosD(angle), mY + (mRadius - 1) * SinD(angle))
	p.LineTo(mX + 5 * CosD(angle + 30), mY + 5 * SinD(angle + 30))
	Return bc.AsyncDrawPath(p, NeedleBrush, True, 0)
End Sub

